Index: LMDZ6/branches/contrails/libf/phylmd/lmdz_lscp_condensation.f90
===================================================================
--- LMDZ6/branches/contrails/libf/phylmd/lmdz_lscp_condensation.f90	(revision 5602)
+++ LMDZ6/branches/contrails/libf/phylmd/lmdz_lscp_condensation.f90	(revision 5609)
@@ -94,11 +94,13 @@
 !**********************************************************************************
 SUBROUTINE condensation_ice_supersat( &
-      klon, dtime, pplay, paprsdn, paprsup, cldfracv, qcondcv, &
-      cldfra_in, qvc_in, qliq_in, qice_in, shear, pbl_eps, cell_area, stratomask, &
-      temp, qtot_in, qsat, gamma_cond, ratqs, keepgoing, &
-      cldfra, qincld, qvc, issrfra, qissr, dcf_sub, dcf_con, dcf_mix, &
-      dqi_adj, dqi_sub, dqi_con, dqi_mix, dqvc_adj, dqvc_sub, dqvc_con, dqvc_mix, &
-      contfra_in, qcont_in, flight_dist, flight_h2o, contfra, qcont, &
-      Tcritcont, qcritcont, potcontfraP, potcontfraNP, &
+      klon, dtime, pplay, paprsdn, paprsup, cfcon, &
+      cldfra_in, qvc_in, qliq_in, qice_in, shear, pbl_eps, cell_area, &
+      temp, qtot_in, qsat, gamma_cond, ratqs, keepgoing, pt_pron_clds, &
+      cldfra_above, icesed_flux, &
+      cldfra, qincld, qvc, issrfra, qissr, dcf_sub, dcf_con, dcf_mix, dcf_sed, &
+      dqi_adj, dqi_sub, dqi_con, dqi_mix, dqi_sed, &
+      dqvc_adj, dqvc_sub, dqvc_con, dqvc_mix, dqvc_sed, &
+      contfra_in, perscontfra_in, qva_in, qia_in, flight_dist, flight_h2o, &
+      contfra, perscontfra, qcont, Tcritcont, qcritcont, potcontfraP, potcontfraNP, &
       dcfa_ini, dqia_ini, dqta_ini, dcfa_sub, dqia_sub, dqta_sub, &
       dcfa_cir, dqta_cir, dcfa_mix, dqia_mix, dqta_mix)
@@ -118,10 +120,9 @@
 
 USE lmdz_lscp_tools, ONLY: calc_qsat_ecmwf, calc_gammasat, GAMMAINC
-USE lmdz_lscp_ini,   ONLY: RCPD, RLSTT, RLVTT, RLMLT, RVTMP2, RTT, RD, RG, RV, RPI, EPS_W
-USE lmdz_lscp_ini,   ONLY: eps, temp_nowater, ok_weibull_warm_clouds
-USE lmdz_lscp_ini,   ONLY: ok_unadjusted_clouds, ok_no_issr_strato
-
-USE lmdz_lscp_ini,   ONLY: depo_coef_cirrus, capa_cond_cirrus, std_subl_pdf_lscp
-USE lmdz_lscp_ini,   ONLY: beta_pdf_lscp, temp_thresh_pdf_lscp
+USE lmdz_lscp_ini,   ONLY: RLSTT, RTT, RD, RG, RV, RPI, EPS_W
+USE lmdz_lscp_ini,   ONLY: eps, temp_nowater, ok_unadjusted_clouds
+
+USE lmdz_lscp_ini,   ONLY: depo_coef_cirrus, capa_cond_cirrus, rho_ice
+USE lmdz_lscp_ini,   ONLY: mu_subl_pdf_lscp, beta_pdf_lscp, temp_thresh_pdf_lscp
 USE lmdz_lscp_ini,   ONLY: std100_pdf_lscp, k0_pdf_lscp, kappa_pdf_lscp
 USE lmdz_lscp_ini,   ONLY: coef_mixing_lscp, coef_shear_lscp
@@ -143,6 +144,5 @@
 REAL,     INTENT(IN)   , DIMENSION(klon) :: paprsdn       ! pressure at the lower interface [Pa]
 REAL,     INTENT(IN)   , DIMENSION(klon) :: paprsup       ! pressure at the upper interface [Pa]
-REAL,     INTENT(IN)   , DIMENSION(klon) :: cldfracv      ! cloud fraction from deep convection [-]
-REAL,     INTENT(IN)   , DIMENSION(klon) :: qcondcv       ! in-cloud condensed specific humidity from deep convection [kg/kg]
+REAL,     INTENT(IN)   , DIMENSION(klon) :: cfcon         ! cloud fraction from deep convection [-]
 REAL,     INTENT(IN)   , DIMENSION(klon) :: cldfra_in     ! cloud fraction [-]
 REAL,     INTENT(IN)   , DIMENSION(klon) :: qvc_in        ! gridbox-mean water vapor in cloud [kg/kg]
@@ -152,5 +152,4 @@
 REAL,     INTENT(IN)   , DIMENSION(klon) :: pbl_eps       ! TKE dissipation [m2/s3]
 REAL,     INTENT(IN)   , DIMENSION(klon) :: cell_area     ! cell area [m2]
-REAL,     INTENT(IN)   , DIMENSION(klon) :: stratomask    ! fraction of stratosphere in the mesh (1 or 0)
 REAL,     INTENT(IN)   , DIMENSION(klon) :: temp          ! temperature [K]
 REAL,     INTENT(IN)   , DIMENSION(klon) :: qtot_in       ! total specific humidity (without precip) [kg/kg]
@@ -159,9 +158,14 @@
 REAL,     INTENT(IN)   , DIMENSION(klon) :: ratqs         ! ratio between the variance of the total water distribution and its average [-]
 LOGICAL,  INTENT(IN)   , DIMENSION(klon) :: keepgoing     ! .TRUE. if a new condensation loop should be computed
+LOGICAL,  INTENT(IN)   , DIMENSION(klon) :: pt_pron_clds  ! .TRUE. if clouds are prognostic in this mesh
+REAL,     INTENT(IN)   , DIMENSION(klon) :: cldfra_above  ! cloud fraction IN THE LAYER ABOVE [-]
+REAL,     INTENT(IN)   , DIMENSION(klon) :: icesed_flux   ! sedimentated ice flux [kg/s/m2]
 !
 ! Input for aviation
 !
 REAL,     INTENT(IN)   , DIMENSION(klon) :: contfra_in    ! input linear contrails fraction [-]
-REAL,     INTENT(IN)   , DIMENSION(klon) :: qcont_in      ! input linear contrails total specific humidity [kg/kg]
+REAL,     INTENT(IN)   , DIMENSION(klon) :: perscontfra_in! input contrail induced cirrus fraction [-]
+REAL,     INTENT(IN)   , DIMENSION(klon) :: qva_in        ! input linear contrails total specific humidity [kg/kg]
+REAL,     INTENT(IN)   , DIMENSION(klon) :: qia_in        ! input linear contrails total specific humidity [kg/kg]
 REAL,     INTENT(IN)   , DIMENSION(klon) :: flight_dist   ! aviation distance flown concentration [m/s/m3]
 REAL,     INTENT(IN)   , DIMENSION(klon) :: flight_h2o    ! aviation emitted H2O concentration [kgH2O/s/m3]
@@ -186,12 +190,15 @@
 REAL,     INTENT(INOUT), DIMENSION(klon) :: dcf_con  ! cloud fraction tendency because of condensation [s-1]
 REAL,     INTENT(INOUT), DIMENSION(klon) :: dcf_mix  ! cloud fraction tendency because of cloud mixing [s-1]
+REAL,     INTENT(INOUT), DIMENSION(klon) :: dcf_sed  ! cloud fraction tendency because of sedimentation [s-1]
 REAL,     INTENT(INOUT), DIMENSION(klon) :: dqi_adj  ! specific ice content tendency because of temperature adjustment [kg/kg/s]
 REAL,     INTENT(INOUT), DIMENSION(klon) :: dqi_sub  ! specific ice content tendency because of sublimation [kg/kg/s]
 REAL,     INTENT(INOUT), DIMENSION(klon) :: dqi_con  ! specific ice content tendency because of condensation [kg/kg/s]
 REAL,     INTENT(INOUT), DIMENSION(klon) :: dqi_mix  ! specific ice content tendency because of cloud mixing [kg/kg/s]
+REAL,     INTENT(INOUT), DIMENSION(klon) :: dqi_sed  ! specific ice content tendency because of sedimentation [kg/kg/s]
 REAL,     INTENT(INOUT), DIMENSION(klon) :: dqvc_adj ! specific cloud water vapor tendency because of temperature adjustment [kg/kg/s]
 REAL,     INTENT(INOUT), DIMENSION(klon) :: dqvc_sub ! specific cloud water vapor tendency because of sublimation [kg/kg/s]
 REAL,     INTENT(INOUT), DIMENSION(klon) :: dqvc_con ! specific cloud water vapor tendency because of condensation [kg/kg/s]
 REAL,     INTENT(INOUT), DIMENSION(klon) :: dqvc_mix ! specific cloud water vapor tendency because of cloud mixing [kg/kg/s]
+REAL,     INTENT(INOUT), DIMENSION(klon) :: dqvc_sed ! specific cloud water vapor tendency because of sedimentation [kg/kg/s]
 !
 !  Diagnostics for aviation
@@ -199,4 +206,5 @@
 !
 REAL,     INTENT(INOUT), DIMENSION(klon) :: contfra      ! linear contrail fraction [-]
+REAL,     INTENT(INOUT), DIMENSION(klon) :: perscontfra  ! linear contrail induced cirrus fraction [-]
 REAL,     INTENT(INOUT), DIMENSION(klon) :: qcont        ! linear contrail specific humidity [kg/kg]
 REAL,     INTENT(INOUT), DIMENSION(klon) :: Tcritcont    ! critical temperature for contrail formation [K]
@@ -220,5 +228,5 @@
 INTEGER :: i
 LOGICAL :: ok_warm_cloud
-REAL, DIMENSION(klon) :: qtot, qcld, qzero
+REAL, DIMENSION(klon) :: qcld, qzero
 REAL, DIMENSION(klon) :: clrfra, qclr
 !
@@ -228,32 +236,43 @@
 !
 ! for unadjusted clouds
-REAL :: qvapincld, qiceincld, qvapincld_new
-!
-! for sublimation
-REAL :: dqt_sub
+REAL :: qiceincld, qvapincld, qvapincld_new
+!
+! for deposition / sublimation
+REAL :: pres_sat, kappa_depsub, tau_depsub
+REAL :: air_thermal_conduct, water_vapor_diff
+REAL :: N_ice
+!
+! for dissipation
+REAL :: pdf_shape
 !
 ! for condensation
 REAL, DIMENSION(klon) :: qsatl, dqsatl
-REAL, DIMENSION(klon) :: pdf_alpha, pdf_scale, pdf_loc
-REAL :: rhl_clr
-REAL :: pdf_ratqs, pdf_skew
-REAL :: pdf_x, pdf_y, pdf_T
-REAL :: pdf_e3, pdf_e4
-REAL :: cf_cond, qt_cond, dqt_con
+REAL, DIMENSION(klon) :: pdf_alpha, pdf_scale, pdf_gamma
+REAL :: rhl_clr, pdf_loc
+REAL :: pdf_e3, pdf_x, pdf_y
+REAL :: dqt_con
+!
+! for sedimentation
+REAL, DIMENSION(klon) :: qice_sedim
+REAL :: clrfra_sed
 !
 ! for mixing
 REAL :: a_mix, bovera, Povera, N_cld_mix, L_mix
-REAL :: clrfra_mix, sigma_mix
+REAL :: cldfra_mix, clrfra_mix, sigma_mix
 REAL :: L_shear, shear_fra
-REAL :: qvapinclr_lim
+REAL :: qiceinmix, qvapinmix_lim, qvapinclr_lim
 REAL :: pdf_fra_above_nuc, pdf_q_above_nuc
 REAL :: pdf_fra_above_lim, pdf_q_above_lim
-REAL :: pdf_fra_below_lim
+REAL :: pdf_fra_below_lim, pdf_q_below_lim
+REAL :: mixed_fraction
 !
 ! for cell properties
-REAL, DIMENSION(klon) :: dz
+REAL :: rho, rhodz, dz
+!
+! for contrails
+REAL :: perscontfra_ratio
+REAL :: contrails_conversion_factor
 
 qzero(:) = 0.
-qtot = qtot_in
 
 !--Calculation of qsat w.r.t. liquid
@@ -269,10 +288,4 @@
   !--formed elsewhere)
   IF (keepgoing(i)) THEN
-
-    !--Initialisation
-    issrfra(i)  = 0.
-    qissr(i)    = 0.
-    contfra(i)  = 0.
-    qcont(i)    = 0.
 
     !--If the temperature is higher than the threshold below which
@@ -281,10 +294,9 @@
     !--If ok_weibull_warm_clouds = .TRUE., the Weibull law is used for
     !--all clouds, and the lognormal scheme is not activated
-    IF ( ( ( temp(i) .GT. temp_nowater ) .AND. .NOT. ok_weibull_warm_clouds ) .OR. &
-         ( ok_no_issr_strato .AND. ( stratomask(i) .EQ. 1. ) ) ) THEN
-
-      pdf_std   = ratqs(i) * qtot(i)
-      pdf_k     = -SQRT( LOG( 1. + (pdf_std / qtot(i))**2 ) )
-      pdf_delta = LOG( qtot(i) / ( gamma_cond(i) * qsat(i) ) )
+    IF ( .NOT. pt_pron_clds(i) ) THEN
+
+      pdf_std   = ratqs(i) * qtot_in(i)
+      pdf_k     = -SQRT( LOG( 1. + (pdf_std / qtot_in(i))**2 ) )
+      pdf_delta = LOG( qtot_in(i) / ( gamma_cond(i) * qsat(i) ) )
       pdf_a     = pdf_delta / ( pdf_k * SQRT(2.) )
       pdf_b     = pdf_k / (2. * SQRT(2.))
@@ -303,5 +315,5 @@
       ELSE
         cldfra(i) = 0.5 * pdf_e1
-        qincld(i) = qtot(i) * pdf_e2 / pdf_e1
+        qincld(i) = qtot_in(i) * pdf_e2 / pdf_e1
         qvc(i) = qsat(i) * cldfra(i)
       ENDIF
@@ -319,17 +331,14 @@
       ok_warm_cloud = ( temp(i) .GT. temp_nowater )
 
-      !--We remove the convection water from the total available water
-      qtot(i) = qtot(i) - ( qcondcv(i) + qsat(i) ) * cldfracv(i)
-
       !--The following barriers ensure that the traced cloud properties
       !--are consistent. In some rare cases, i.e. the cloud water vapor
       !--can be greater than the total water in the gridbox
-      cldfra(i) = MAX(0., MIN(1. - cldfracv(i), cldfra_in(i)))
-      qcld(i)   = MAX(0., MIN(qtot(i), qliq_in(i) + qice_in(i) + qvc_in(i)))
+      cldfra(i) = MAX(0., MIN(1. - cfcon(i), cldfra_in(i)))
+      qcld(i)   = MAX(0., MIN(qtot_in(i), qliq_in(i) + qice_in(i) + qvc_in(i)))
       qvc(i)    = MAX(0., MIN(qcld(i), qvc_in(i)))
 
       !--Initialise clear fraction properties
-      clrfra(i) = ( 1. - cldfracv(i) ) - cldfra(i)
-      qclr(i) = qtot(i) - qcld(i)
+      clrfra(i) = MAX(0., MIN(1., ( 1. - cfcon(i) ) - cldfra(i)))
+      qclr(i) = qtot_in(i) - qcld(i)
 
       dcf_sub(i)  = 0.
@@ -344,18 +353,105 @@
       dqi_mix(i)  = 0.
       dqvc_mix(i) = 0.
+      dcf_sed(i)  = 0.
+      dqi_sed(i)  = 0.
+      dqvc_sed(i) = 0.
+
+      IF ( icesed_flux(i) .GT. 0. ) THEN
+        !--If ice sedimentation is activated, the quantity of sedimentated ice was added
+        !--to the total water vapor in the precipitation routine. Here we remove it
+        !--(it will be reincluded later)
+        qice_sedim(i) = icesed_flux(i) / ( paprsdn(i) - paprsup(i) ) * RG * dtime
+        qclr(i) = qclr(i) - qice_sedim(i)
+      ENDIF
 
       !--Initialisation of the cell properties
       !--Dry density [kg/m3]
-      !rho = pplay(i) / temp(i) / RD
+      rho = pplay(i) / temp(i) / RD
       !--Dry air mass [kg/m2]
-      !rhodz = ( paprsdn(i) - paprsup(i) ) / RG
+      rhodz = ( paprsdn(i) - paprsup(i) ) / RG
       !--Cell thickness [m]
-      !dz = rhodz / rho
-      dz(i) = ( paprsdn(i) - paprsup(i) ) / pplay(i) * temp(i) * RD / RG
+      dz = rhodz / rho
+
+      !--If ok_unadjusted_clouds is set to TRUE, then the saturation adjustment
+      !--hypothesis is lost, and the vapor in the cloud is purely prognostic.
+      !
+      !--The deposition equation is
+      !-- dmi/dt = alpha*4pi*C*Svi / ( R_v*T/esi/Dv + Ls/ka/T * (Ls/R_v/T - 1) )
+      !--from Lohmann et al. (2016), where
+      !--alpha is the deposition coefficient [-]
+      !--mi is the mass of one ice crystal [kg]
+      !--C is the capacitance of an ice crystal [m]
+      !--Svi is the supersaturation ratio equal to (qvc - qsat)/qsat [-]
+      !--R_v is the specific gas constant for humid air [J/kg/K]
+      !--T is the temperature [K]
+      !--esi is the saturation pressure w.r.t. ice [Pa]
+      !--Dv is the diffusivity of water vapor [m2/s]
+      !--Ls is the specific latent heat of sublimation [J/kg/K]
+      !--ka is the thermal conductivity of dry air [J/m/s/K]
+      !
+      !--alpha is a coefficient to take into account the fact that during deposition, a water
+      !--molecule cannot join the crystal from everywhere, it must do so that the crystal stays
+      !--coherent (with the same structure). It has no impact for sublimation.
+      !--We fix alpha = depo_coef_cirrus (=0.5 by default following Lohmann et al. (2016))
+      !--during deposition, and alpha = 1. during sublimation.
+      !--The capacitance of the ice crystals is proportional to a parameter capa_cond_cirrus
+      !-- C = capa_cond_cirrus * rm_ice
+      !
+      !--We have qice = Nice * mi, where Nice is the ice crystal
+      !--number concentration per kg of moist air
+      !--HYPOTHESIS 1: the ice crystals are spherical, therefore
+      !-- mi = 4/3 * pi * rm_ice**3 * rho_ice
+      !--HYPOTHESIS 2: the ice crystals are monodisperse with the
+      !--initial radius rm_ice_0.
+      !--NB. this is notably different than the assumption
+      !--of a distributed qice in the cloud made in the sublimation process;
+      !--should it be consistent?
+      !
+      !--As the deposition process does not create new ice crystals,
+      !--and because we assume a same rm_ice value for all crystals
+      !--therefore the sublimation process does not destroy ice crystals
+      !--(or, in a limit case, it destroys all ice crystals), then
+      !--Nice is a constant during the sublimation/deposition process.
+      !-- dmi = dqi, et Nice = qi_0 / ( 4/3 RPI rm_ice_0**3 rho_ice )
+      !
+      !--The deposition equation then reads:
+      !-- dqi/dt = alpha*4pi*capa_cond_cirrus*rm_ice*(qvc-qsat)/qsat / ( R_v*T/esi/Dv + Ls/ka/T * (Ls/R_v/T - 1) ) * Nice
+      !-- dqi/dt = alpha*4pi*capa_cond_cirrus* (qi / qi_0)**(1/3) *rm_ice_0*(qvc-qsat)/qsat &
+      !--             / ( R_v*T/esi/Dv + Ls/ka/T * (Ls*R_v/T - 1) ) &
+      !--                         * qi_0 / ( 4/3 RPI rm_ice_0**3 rho_ice )
+      !-- dqi/dt = qi**(1/3) * (qvc - qsat) * qi_0**(2/3) &
+      !--  *alpha/qsat*capa_cond_cirrus/ (R_v*T/esi/Dv + Ls/ka/T*(Ls*R_v/T - 1)) / ( 1/3 rm_ice_0**2 rho_ice )
+      !--and we have
+      !-- dqvc/dt = - qi**(1/3) * (qvc - qsat) / kappa * alpha * qi_0**(2/3) / rm_ice_0**2
+      !-- dqi/dt  =   qi**(1/3) * (qvc - qsat) / kappa * alpha * qi_0**(2/3) / rm_ice_0**2
+      !--where kappa = 1/3*rho_ice/capa_cond_cirrus*qsat*(R_v*T/esi/Dv + Ls/ka/T*(Ls/R_v/T - 1))
+      !
+      !--This system of equations can be resolved with an exact
+      !--explicit numerical integration, having one variable resolved
+      !--explicitly, the other exactly. The exactly resolved variable is
+      !--the one decreasing, so it is qvc if the process is
+      !--condensation, qi if it is sublimation.
+      !
+      !--kappa is computed as an initialisation constant, as it depends only
+      !--on temperature and other pre-computed values
+      pres_sat = qsat(i) / ( EPS_W + ( 1. - EPS_W ) * qsat(i) ) * pplay(i)
+      !--This formula for air thermal conductivity comes from Beard and Pruppacher (1971)
+      air_thermal_conduct = ( 5.69 + 0.017 * ( temp(i) - RTT ) ) * 1.e-3 * 4.184
+      !--This formula for water vapor diffusivity comes from Hall and Pruppacher (1976)
+      water_vapor_diff = 0.211 * ( temp(i) / RTT )**1.94 * ( 101325. / pplay(i) ) * 1.e-4
+      !--Median ice crystal concentration [#/m3] in cirrus clouds from Kramer et al (2020)
+      N_ice = 0.003 * 1e6
+      !--NB. the greater kappa_depsub, the lower the efficiency of the
+      !--deposition/sublimation process
+      kappa_depsub = ( 4. / 3. * RPI * N_ice / rho * rho_ice )**(1./3.) &
+                   * qsat(i) / ( 4. * RPI * capa_cond_cirrus * N_ice / rho ) &
+                   * ( RV * temp(i) / water_vapor_diff / pres_sat &
+                     + RLSTT / air_thermal_conduct / temp(i) * ( RLSTT / RV / temp(i) - 1. ) )
 
       !--If contrails are activated
       IF ( ok_plane_contrail ) THEN
-        contfra(i) = contfra_in(i)
-        qcont(i) = qcont_in(i)
+        contfra(i) = MAX(0., MIN(cldfra(i), contfra_in(i)))
+        perscontfra(i) = MAX(0., MIN(cldfra(i), perscontfra_in(i)))
+        qcont(i) = MAX(0., MIN(qcld(i), qva_in(i) + qia_in(i)))
 
         dcfa_ini(i) = 0.
@@ -370,4 +466,8 @@
         dqia_mix(i) = 0.
         dqta_mix(i) = 0.
+      ELSE
+        contfra(i) = 0.
+        perscontfra(i) = 0.
+        qcont(i) = 0.
       ENDIF
 
@@ -379,9 +479,14 @@
       !--If there is a contrail
       IF ( contfra(i) .GT. eps ) THEN
+        !--We remove contrails from the main class
+        cldfra(i) = cldfra(i) - contfra(i)
+        qcld(i) = qcld(i) - qcont(i)
+        qvc(i) = qvc(i) - qsat(i) * contfra(i)
+
         !--The contrail is always adjusted to saturation
         qiceincld = ( qcont(i) / contfra(i) - qsat(i) )
         
         !--If the ice water content is too low, the cloud is purely sublimated
-        IF ( qiceincld .LT. eps ) THEN
+        IF ( qiceincld .LT. ( 0.005 * qsat(i) ) ) THEN
           dcfa_sub(i) = - contfra(i)
           dqia_sub(i) = - qiceincld * contfra(i)
@@ -389,13 +494,11 @@
           contfra(i) = 0.
           qcont(i) = 0.
-          clrfra(i) = clrfra(i) + dcfa_sub(i)
-          qclr(i) = qclr(i) + dqta_sub(i)
-        ELSE
-          !--We remove contrails from the main class
-          cldfra(i) = cldfra(i) - contfra(i)
-          qcld(i) = qcld(i) - qcont(i)
-          qvc(i) = qvc(i) - qsat(i) * contfra(i)
+          clrfra(i) = MIN(1., clrfra(i) - dcfa_sub(i))
+          qclr(i) = qclr(i) - dqta_sub(i)
         ENDIF   ! qiceincld .LT. eps
       ENDIF ! contfra(i) .GT. eps
+
+      !--If there is a contrail induced cirrus, we save the ratio
+      perscontfra_ratio = perscontfra(i) / MAX(eps, cldfra(i))
 
 
@@ -421,53 +524,44 @@
           qcld(i) = 0.
           qvc(i) = 0.
-          clrfra(i) = clrfra(i) - dcf_sub(i)
+          clrfra(i) = MIN(1., clrfra(i) - dcf_sub(i))
           qclr(i) = qclr(i) - dqvc_sub(i) - dqi_sub(i)
-
-          !--If all the ice has been sublimated, we sublimate
-          !--completely the cloud and do not activate the sublimation
-          !--process
-          qvapincld_new = 0.
 
         !--Else, the cloud is adjusted and sublimated
         ELSE
 
-          !--The vapor in cloud cannot be higher than the
-          !--condensation threshold
-          qvapincld = MIN(qvapincld, gamma_cond(i) * qsat(i))
-          qiceincld = ( qcld(i) / cldfra(i) - qvapincld )
+          !IF ( qiceincld .LT. ( 0.005 * qsat(i) ) ) THEN
+          !  dcf_sub(i) = ( qiceincld / ( 0.005 * qsat(i) ) - 1. ) * cldfra(i)
+          !  dqvc_sub(i) = qvapincld * dcf_sub(i)
+
+          !  cldfra(i) = cldfra(i) + dcf_sub(i)
+          !  qcld(i) = qcld(i) + dqvc_sub(i)
+          !  qvc(i) = qvc(i) + dqvc_sub(i)
+          !  clrfra(i) = MIN(1., clrfra(i) - dcf_sub(i))
+          !  qclr(i) = qclr(i) - dqvc_sub(i)
+          !ENDIF
 
           IF ( ok_unadjusted_clouds .AND. .NOT. ok_warm_cloud ) THEN
-            qvapincld_new = QVAPINCLD_DEPSUB( &
-                qvapincld, qiceincld, temp(i), qsat(i), pplay(i), dtime)
-            IF ( qvapincld_new .EQ. 0. ) THEN
-              !--If all the ice has been sublimated, we sublimate
-              !--completely the cloud and do not activate the dissipation
-              !--process
-              !--Tendencies and diagnostics
-              dcf_sub(i) = - cldfra(i)
-              dqvc_sub(i) = - qvc(i)
-              dqi_sub(i) = - ( qcld(i) - qvc(i) )
-
-              cldfra(i) = 0.
-              qcld(i) = 0.
-              qvc(i) = 0.
-              clrfra(i) = clrfra(i) - dcf_sub(i)
-              qclr(i) = qclr(i) - dqvc_sub(i) - dqi_sub(i)
-            ENDIF
+            IF ( qvapincld .GE. qsat(i) ) THEN
+              !--If the cloud is initially supersaturated
+              !--Exact explicit integration (qvc exact, qice explicit)
+              tau_depsub = 1. / ( depo_coef_cirrus * qiceincld**(1./3.) * kappa_depsub )
+            ELSE
+              !--If the cloud is initially subsaturated
+              !--Exact explicit integration (qvc exact, qice explicit)
+              !--Same but depo_coef_cirrus = 1
+              tau_depsub = 1. / ( qiceincld**(1./3.) * kappa_depsub )
+            ENDIF ! qvapincld .GT. qsat
+            qvapincld_new = qsat(i) + ( qvapincld - qsat(i) ) * EXP( - dtime / tau_depsub )
+            !--If all the ice is sublimated
+            IF ( qvapincld_new .GE. ( qvapincld + qiceincld ) ) qvapincld_new = 0.
           ELSE
             !--We keep the saturation adjustment hypothesis, and the vapor in the
             !--cloud is set equal to the saturation vapor
-            qvapincld_new = qsat(i)
+            IF ( ( qvapincld + qiceincld ) .GT. qsat(i) ) THEN
+              qvapincld_new = qsat(i)
+            ELSE
+              qvapincld_new = 0.
+            ENDIF
           ENDIF ! ok_unadjusted_clouds
-          
-          !--Adjustment of the IWC to the new vapor in cloud
-          !--(this can be either positive or negative)
-          dqvc_adj(i) = ( qvapincld_new * cldfra(i) - qvc(i) )
-          dqi_adj(i) = - dqvc_adj(i)
-
-          !--Add tendencies
-          !--The vapor in the cloud is updated, but not qcld as it is constant
-          !--through this process, as well as cldfra which is unmodified
-          qvc(i) = MAX(0., MIN(qcld(i), qvc(i) + dqvc_adj(i)))
           
 
@@ -477,29 +571,61 @@
 
           !--If the dissipation process must be activated
-          IF ( qvapincld_new .GT. 0. ) THEN
-            !--Normal distribution around qvapincld + qiceincld with width
-            !--constant in the RHi space
-            pdf_y = ( qvapincld_new - qvapincld - qiceincld ) &
-                  / ( std_subl_pdf_lscp / 100. * qsat(i))
-            pdf_e1 = 0.5 * ( 1. + ERF( pdf_y / SQRT(2.) ) )
-            pdf_e2 = EXP( - pdf_y**2 / 2. ) / SQRT( 2. * RPI )
-
-            dcf_sub(i) = - cldfra(i) * pdf_e1
-            dqt_sub    = - cldfra(i) * ( ( qvapincld + qiceincld ) * pdf_e1 &
-                                       - std_subl_pdf_lscp / 100. * qsat(i) * pdf_e2 )
+          !IF ( cldfra(i) .GT. eps ) THEN
+          IF ( qvapincld_new .GT. qvapincld ) THEN
+            !--Gamma distribution starting at qvapincld
+            pdf_shape = ( mu_subl_pdf_lscp + 1. ) / qiceincld
+            pdf_y = pdf_shape * ( qvapincld_new - qvapincld )
+            pdf_e1 = GAMMAINC ( mu_subl_pdf_lscp + 1. , pdf_y )
+            pdf_e2 = GAMMAINC ( mu_subl_pdf_lscp + 2. , pdf_y )
 
             !--Tendencies and diagnostics
-            dqvc_sub(i) = dqt_sub
+            dcf_sub(i)  = - cldfra(i) * pdf_e1
+            dqi_sub(i)  = - cldfra(i) * pdf_e2 / pdf_shape
+            dqvc_sub(i) = dcf_sub(i) * qvapincld
 
             !--Add tendencies
-            cldfra(i) = cldfra(i) + dcf_sub(i)
-            qcld(i)   = qcld(i) + dqt_sub
+            cldfra(i) = MAX(0., cldfra(i) + dcf_sub(i))
+            qcld(i)   = qcld(i) + dqvc_sub(i) + dqi_sub(i)
             qvc(i)    = qvc(i) + dqvc_sub(i)
-            clrfra(i) = clrfra(i) - dcf_sub(i)
-            qclr(i)   = qclr(i) - dqt_sub
+            clrfra(i) = MIN(1., clrfra(i) - dcf_sub(i))
+            qclr(i)   = qclr(i) - dqvc_sub(i) - dqi_sub(i)
           ENDIF ! qvapincld_new .GT. 0.
+
+
+          !------------------------------------
+          !--       PHASE ADJUSTMENT        --
+          !------------------------------------
+
+          IF ( qvapincld_new .EQ. 0. ) THEN
+            !--If all the ice has been sublimated, we sublimate
+            !--completely the cloud and do not activate the dissipation
+            !--process
+            !--Tendencies and diagnostics
+            dcf_sub(i) = - cldfra(i)
+            dqvc_sub(i) = - qvc(i)
+            dqi_sub(i) = - ( qcld(i) - qvc(i) )
+
+            cldfra(i) = 0.
+            qcld(i) = 0.
+            qvc(i) = 0.
+            clrfra(i) = MIN(1., clrfra(i) - dcf_sub(i))
+            qclr(i) = qclr(i) - dqvc_sub(i) - dqi_sub(i)
+          ELSE
+            !--Adjustment of the IWC to the new vapor in cloud
+            !--(this can be either positive or negative)
+            dqvc_adj(i) = ( qvapincld_new * cldfra(i) - qvc(i) )
+            dqi_adj(i) = - dqvc_adj(i)
+
+            !--Add tendencies
+            !--The vapor in the cloud is updated, but not qcld as it is constant
+            !--through this process, as well as cldfra which is unmodified
+            qvc(i) = MAX(0., MIN(qcld(i), qvc(i) + dqvc_adj(i)))
+          ENDIF
 
         ENDIF   ! qiceincld .LT. eps
       ENDIF ! cldfra(i) .GT. eps
+
+      !--If there is a contrail induced cirrus, we restore it
+      perscontfra(i) = perscontfra_ratio * cldfra(i)
 
 
@@ -519,5 +645,5 @@
         !--Calculation of the properties of the PDF
         !--Parameterization from IAGOS observations
-        !--pdf_e1 and pdf_e2 will be reused below
+        !--pdf_alpha, pdf_scale and pdf_gamma will be reused below
 
         !--Coefficient for standard deviation:
@@ -537,14 +663,15 @@
         pdf_alpha(i) = EXP( rhl_clr / 100. ) * pdf_e3
         
-        IF ( ok_warm_cloud ) THEN
-          !--If the statistical scheme is activated, the standard deviation is adapted
-          !--to depend on the pressure level. It is multiplied by ratqs, so that near the
-          !--surface std is almost 0, and upper than about 450 hPa the std is left untouched
-          pdf_std = pdf_std * ratqs(i)
-        ENDIF
-
-        pdf_e2 = GAMMA(1. + 1. / pdf_alpha(i))
-        pdf_scale(i) = MAX(eps, pdf_std / SQRT( GAMMA(1. + 2. / pdf_alpha(i)) - pdf_e2**2 ))
-        pdf_loc(i) = rhl_clr - pdf_scale(i) * pdf_e2
+        !IF ( ok_warm_cloud ) THEN
+        !  !--If the statistical scheme is activated, the standard deviation is adapted
+        !  !--to depend on the pressure level. It is multiplied by ratqs, so that near the
+        !  !--surface std is almost 0, and upper than about 450 hPa the std is left untouched
+        !  pdf_std = pdf_std * ratqs(i)
+        !ENDIF
+
+        pdf_gamma(i) = GAMMA(1. + 1. / pdf_alpha(i))
+        pdf_scale(i) = MAX(eps, pdf_std / SQRT( &
+                                    GAMMA(1. + 2. / pdf_alpha(i)) - pdf_gamma(i)**2 ))
+        pdf_loc = rhl_clr - pdf_scale(i) * pdf_gamma(i)
 
         !--Calculation of the newly condensed water and fraction (pronostic)
@@ -553,14 +680,14 @@
 
         pdf_x = gamma_cond(i) * qsat(i) / qsatl(i) * 100.
-        pdf_y = ( MAX( pdf_x - pdf_loc(i), 0. ) / pdf_scale(i) ) ** pdf_alpha(i)
+        pdf_y = ( MAX( pdf_x - pdf_loc, 0. ) / pdf_scale(i) ) ** pdf_alpha(i)
         pdf_e3 = GAMMAINC ( 1. + 1. / pdf_alpha(i) , pdf_y )
-        pdf_e3 = pdf_scale(i) * ( 1. - pdf_e3 ) * pdf_e2
-        cf_cond = EXP( - pdf_y )
-        qt_cond = ( pdf_e3 + pdf_loc(i) * cf_cond ) * qsatl(i) / 100.
-
-        IF ( cf_cond .GT. eps ) THEN
-
-          dcf_con(i) = clrfra(i) * cf_cond
-          dqt_con = clrfra(i) * qt_cond
+        pdf_e3 = pdf_scale(i) * ( 1. - pdf_e3 ) * pdf_gamma(i)
+        pdf_fra_above_nuc = EXP( - pdf_y )
+        pdf_q_above_nuc = ( pdf_e3 + pdf_loc * pdf_fra_above_nuc ) * qsatl(i) / 100.
+
+        IF ( pdf_fra_above_nuc .GT. eps ) THEN
+
+          dcf_con(i) = clrfra(i) * pdf_fra_above_nuc
+          dqt_con = clrfra(i) * pdf_q_above_nuc
 
           !--Barriers (should be useless
@@ -574,22 +701,21 @@
             qvapincld = gamma_cond(i) * qsat(i)
             qiceincld = dqt_con / dcf_con(i) - gamma_cond(i) * qsat(i)
-            qvapincld_new = QVAPINCLD_DEPSUB( &
-                qvapincld, qiceincld, temp(i), qsat(i), pplay(i), dtime / 2.)
-            qvapincld = qvapincld_new
+            tau_depsub = 1. / ( depo_coef_cirrus * qiceincld**(1./3.) * kappa_depsub )
+            qvapincld_new = qsat(i) + ( qvapincld - qsat(i) ) * EXP( - dtime / 2. / tau_depsub )
           ELSE
             !--We keep the saturation adjustment hypothesis, and the vapor in the
             !--newly formed cloud is set equal to the saturation vapor.
-            qvapincld = qsat(i)
+            qvapincld_new = qsat(i)
           ENDIF
 
           !--Tendency on cloud vapor and diagnostic
-          dqvc_con(i) = qvapincld * dcf_con(i)
+          dqvc_con(i) = qvapincld_new * dcf_con(i)
           dqi_con(i) = dqt_con - dqvc_con(i)
 
           !--Add tendencies
-          cldfra(i)  = cldfra(i) + dcf_con(i)
+          cldfra(i)  = MIN(1., cldfra(i) + dcf_con(i))
           qcld(i)    = qcld(i) + dqt_con
           qvc(i)     = qvc(i) + dqvc_con(i)
-          clrfra(i)  = clrfra(i) - dcf_con(i)
+          clrfra(i)  = MAX(0., clrfra(i) - dcf_con(i))
           qclr(i)    = qclr(i) - dqt_con
 
@@ -597,4 +723,7 @@
       ENDIF ! ( 1. - cldfra(i) ) .GT. eps
 
+
+      !--If there is a contrail induced cirrus, we save the ratio
+      perscontfra_ratio = perscontfra(i) / MAX(eps, cldfra(i))
 
       !--------------------------------------
@@ -658,4 +787,8 @@
         clrfra_mix = N_cld_mix * RPI / cell_area(i) &
                    * ( a_mix * ( 1. + bovera ) * L_mix + L_mix**2 )
+        !--The fraction of clear sky mixed is
+        !-- N_cld_mix * ( a * b - (a - L_mix) * (b - L_mix) ) * RPI / cell_area
+        cldfra_mix = N_cld_mix * RPI / cell_area(i) &
+                   * ( a_mix * ( 1. + bovera ) * L_mix - L_mix**2 )
 
 
@@ -666,5 +799,5 @@
         !--semi-major axis (a_mix), on the entire cell heigh dz.
         !--The increase in size is
-        L_shear = coef_shear_lscp * shear(i) * dz(i) * dtime
+        L_shear = coef_shear_lscp * shear(i) * dz * dtime
         !--therefore, the fraction of clear sky mixed is
         !-- N_cld_mix * ( (a + L_shear) * b - a * b ) * RPI / 2. / cell_area
@@ -678,9 +811,10 @@
         !--mixed clouds are different.
         clrfra_mix = clrfra_mix + shear_fra
-
+        cldfra_mix = cldfra_mix + shear_fra
 
         !-- PART 3 - CALCULATION OF THE MIXING PROPERTIES
 
-        clrfra_mix = MIN( clrfra_mix, clrfra(i) )
+        clrfra_mix = MAX(eps, MIN(clrfra(i), clrfra_mix))
+        cldfra_mix = MAX(eps, MIN(cldfra(i), cldfra_mix))
 
         !--We compute the limit vapor in clear sky where the mixed cloud could not
